<!DOCTYPE html>
<html lang="en">
<head>
    <title>Task 43.140 Confirm/Cancel đơn hàng</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    <!-- Import Datatable sau jquery -->
    <!-- Import them style bootstrap cho datatable -->
    <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
    <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
    <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
</head>
<body>
    <div class="container">
        <h2 style="text-align: center;">DANH SÁCH ĐƠN HÀNG</h2>
        <table class="table table-bordered table-striped table-hover table-dark" id="order-table">
          <thead>
            <tr>
              <th>Order ID</th>
              <th>Kích cỡ combo</th>
              <th>Loại pizza</th>
              <th>Nước uống</th>
              <th>Thành tiền</th>
              <th>Họ và tên</th>
              <th>Số điện thoại</th>
              <th>Trạng thái</th>
              <th>Chi tiết</th>
            </tr>
        </table>
      </div>
  <!-- Modal Order Detail -->
<div id="order-detail-modal" class="modal fade " tabindex="-1">
  <div class="modal-dialog modal-xl">
    <div class="modal-content">
      <div class="modal-header">
        <h5 class="modal-title" id="h5-modal-title">Order detail</h5>
        <button class="close" data-dismiss="modal">&times;</button>
      </div>
      <div class="modal-body">
        <form>
          <div class="row form-group">
            <div class="col-sm-2">
              <label for="input-order-id">Order ID (mã đơn hàng)</label>
            </div>
            <div class="col-sm-4">
              <input type="text" id="input-order-id" name="order-id" placeholder="" class="form-control">
            </div>
            <div class="col-sm-2">
              <label for="input-combo-size">Cỡ combo</label>
            </div>
            <div class="col-sm-4">
              <select class="form-control" id = "select-co-combo" aria-label="co-combo"></select>
            </div>
          </div>
          <div class="row form-group">
            <div class="col-sm-2">
              <label for="input-duong-kinh-pizza">Đường kính pizza</label>
            </div>
            <div class="col-sm-4">
              <input type="text" id="input-duong-kinh-pizza" name="duong-kinh-pizza" placeholder="" class="form-control">
            </div>
            <div class="col-sm-2">
              <label for="input-suon-nuong">Sườn nướng (miếng)</label>
            </div>
            <div class="col-sm-4">
              <input type="text" id="input-suon-nuong" name="duon-nuong" placeholder="" class="form-control">
            </div>
          </div>
          <div class="row form-group">
            <div class="col-sm-2">
              <label for="input-do-uong">Đồ uống</label>
            </div>
            <div class="col-sm-4">
              <select class="form-control" id = "select-do-uong" aria-label="do-uong"></select>
            </div>
            <div class="col-sm-2">
              <label for="input-so-luong-nuoc-uong">Số lượng nước uống</label>
            </div>
            <div class="col-sm-4">
              <input type="text" id="input-so-luong-nuoc-uong" name="so-luong-nuoc-uong" placeholder="" class="form-control">
            </div>
          </div>
          <div class="row form-group">
              <div class="col-sm-2">
                  <label for="input-voucher-id">Voucher ID (mã voucher)</label>
                </div>
                <div class="col-sm-4">
                  <input type="text" id="input-voucher-id" name="voucher-id" placeholder="" class="form-control">
                </div>
                <div class="col-sm-2">
                  <label for="input-pizza-type">Loại pizza (Pizza type)</label>
                </div>
                <div class="col-sm-4">
                  <input type="text" id="input-pizza-type" name="pizza-type" placeholder="" class="form-control">
                </div>
          </div>
          <div class="row form-group">
              <div class="col-sm-2">
                  <label for="input-salad">Salad (g)</label>
                </div>
                <div class="col-sm-4">
                  <input type="text" id="input-salad" name="salad" placeholder="" class="form-control">
                </div>
                <div class="col-sm-2">
                  <label for="input-thanh-tien">Thành tiền</label>
                </div>
                <div class="col-sm-4">
                  <input type="text" id="input-thanh-tien" name="thanh-tien" placeholder="" class="form-control">
                </div>
          </div>
          <div class="row form-group">
              <div class="col-sm-2">
                  <label for="input-discount">Giảm giá (Discount)</label>
                </div>
                <div class="col-sm-4">
                  <input type="text" id="input-discount" name="discount" placeholder="" class="form-control">
                </div>
                <div class="col-sm-2">
                  <label for="input-full-name">Họ và tên</label>
                </div>
                <div class="col-sm-4">
                  <input type="text" id="input-full-name" name="full-name" placeholder="" class="form-control">
                </div>
          </div>
          <div class="row form-group">
              <div class="col-sm-2">
                  <label for="input-email">Email</label>
                </div>
                <div class="col-sm-4">
                  <input type="text" id="input-email" name="email" placeholder="" class="form-control">
                </div>
                <div class="col-sm-2">
                  <label for="input-phone-number">Số điện thoại</label>
                </div>
                <div class="col-sm-4">
                  <input type="text" id="input-phone-number" name="phone-number" placeholder="" class="form-control">
                </div>
          </div>
          <div class="row form-group">
              <div class="col-sm-2">
                  <label for="input-address">Địa chỉ</label>
                </div>
                <div class="col-sm-4">
                  <input type="text" id="input-address" name="address" placeholder="" class="form-control">
                </div>
                <div class="col-sm-2">
                  <label for="input-message">Lời nhắn</label>
                </div>
                <div class="col-sm-4">
                  <input type="text" id="input-message" name="message" placeholder="" class="form-control">
                </div>
          </div>
          <div class="row form-group">
              <div class="col-sm-2">
                  <label for="input-order-status">Trạng thái đơn hàng</label>
                </div>
                <div class="col-sm-4">
                  <input type="text" id="input-order-status" name="order-status" placeholder="" class="form-control">
                </div>
                <div class="col-sm-2">
                  <label for="input-ngay-tao-don">Ngày tạo đơn</label>
                </div>
                <div class="col-sm-4">
                  <input type="text" id="input-ngay-tao-don" name="ngay-tao-don" placeholder="" class="form-control">
                </div>
          </div>
          <div class="row form-group">
              <div class="col-sm-2">
                  <label for="input-ngay-cap-nhat">Ngày cập nhật</label>
                </div>
                <div class="col-sm-4">
                  <input type="text" id="input-ngay-cap-nhat" name="ngay-cap-nhat" placeholder="" class="form-control">
                </div>
          </div>
          
        </form>
      </div>
      <div class="modal-footer">
        <button class="btn btn-success" id="btn-confirm">Confirm</button>
        <button class="btn btn-danger" id="btn-cancel" data-dismiss="modal">Cancel</button>
      </div>
    </div>
  </div>
</div>
</body>
<script>
     "use strict";
    $(document).ready(function() {
        /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
        var gOrderObject = [];
        var gId = "";
        var gOrderID = "";
        var gOrderObjectId = [];
        var gPizzaSize = ["S", "M", "L"];
        
        const gCOLUMN_ORDER_ID = 0;
        const gCOLUMN_KICH_CO_COMBO = 1;
        const gCOLUMN_LOAI_PIZZA = 2;
        const gCOLUMN_NUOC_UONG = 3;
        const gCOLUMN_THANH_TIEN = 4 ;
        const gCOLUMN_HO_VA_TEN = 5;
        const gCOLUMN_SO_DIEN_THOAI = 6;
        const gCOLUMN_TRANG_THAI = 7;
        const gCOLUMN_CHI_TIET = 8;
    
        const gCOLUMN_DATA = ["orderId", "kichCo", "loaiPizza", "idLoaiNuocUong", "thanhTien", "hoTen", "soDienThoai", "trangThai", "chiTiet"];
        // định nghĩa table  - chưa có data
        var gOrderTable = $("#order-table").DataTable( {
        // Khai báo các cột của datatable
        "columns" : [
            { "data" : gCOLUMN_DATA[gCOLUMN_ORDER_ID] },
            { "data" : gCOLUMN_DATA[gCOLUMN_KICH_CO_COMBO] },
            { "data" : gCOLUMN_DATA[gCOLUMN_LOAI_PIZZA] },
            { "data" : gCOLUMN_DATA[gCOLUMN_NUOC_UONG] },
            { "data" : gCOLUMN_DATA[gCOLUMN_THANH_TIEN] },
            { "data" : gCOLUMN_DATA[gCOLUMN_HO_VA_TEN] },
            { "data" : gCOLUMN_DATA[gCOLUMN_SO_DIEN_THOAI] },
            { "data" : gCOLUMN_DATA[gCOLUMN_TRANG_THAI] },
            { "data" : gCOLUMN_DATA[gCOLUMN_CHI_TIET] }
        ],
        // Ghi đè nội dung của cột action, chuyển thành button chi tiết
        "columnDefs": [ 
        {
            "targets": gCOLUMN_CHI_TIET,
            "defaultContent": "<button class='info-order btn btn-info'>Chi tiết</button>"
        }]
        });
        /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
        onPageLoading();
        getDrinkList();
        loadPizzaSizeToModal(gPizzaSize);
        $("#order-table").on("click", ".info-order", function() {
            onButtonChiTietClick(this); // this là button được ấn
        });
        $("#btn-confirm").on("click", function() {
            onBtnConfirmClick(gId);
        });
        $("#btn-cancel").on("click", function() {
            onBtnCancelClick(gId);
        });
        /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
        // hàm chạy khi trang được load
    function onPageLoading() {
      // lấy data từ server
      callApiToGetAllOrder();
      loadDataToTable(gOrderObject);
    }
    function onBtnConfirmClick(paramId){
      "use strict";
      var vObjectRequest = {
            trangThai: "confirmed" //3: trang thai open, confirmed, cancel tùy tình huống
        }
        console.log("Nút Confirm được nhấn!");
        console.log("Id là: ", gId);
        callApiToUpdateAndCancel(paramId,vObjectRequest);
        callApiToGetAllOrder();
        loadDataToTable(gOrderObject);
        $("#order-detail-modal").modal("hide");
    }
    function onBtnCancelClick(paramId){
      "use strict";
      var vObjectRequest = {
            trangThai: "cancel" //3: trang thai open, confirmed, cancel tùy tình huống
        }
        console.log("Nút Cancel được nhấn!");
        console.log("Id là: ", gId);
        callApiToUpdateAndCancel(paramId,vObjectRequest);
        callApiToGetAllOrder();
        loadDataToTable(gOrderObject);
        $("#order-detail-modal").modal("hide");
    }
    function callApiToGetAllOrder(){
      "use strict";
      $.ajax({
        url: "http://42.115.221.44:8080/devcamp-pizza365/orders",
        async: false,
        type: "GET",
        dataType: 'json',
        success: function(responseObject){
          //debugger;
          gOrderObject = responseObject;
          console.log(gOrderObject);
        },
            error: function(error){
            console.assert(error.responseText);
        }
      });
    }
    function callApiToUpdateAndCancel(paramId, paramObjectRequest){
      "use strict";
      const vBASE_URL = "http://42.115.221.44:8080/devcamp-pizza365/orders";
      $.ajax({
          url: vBASE_URL + "/" + paramId,
          async: false,
          type: "PUT",
          data: JSON.stringify(paramObjectRequest),
          contentType: "application/json;charset=UTF-8",
          success: function(responseObject){
            //debugger;
            console.log(responseObject);
          },
            error: function(error){
            console.assert(error.responseText);
          }
      })
    }
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình */
    // load data to table
    function loadDataToTable(paramResponseObject) {
      //Xóa toàn bộ dữ liệu đang có của bảng
      gOrderTable.clear();
      //Cập nhật data cho bảng 
      gOrderTable.rows.add(paramResponseObject);
      //Cập nhật lại giao diện hiển thị bảng
      gOrderTable.draw();
    }
    function onButtonChiTietClick(paramChiTietButton) {
      //Xác định thẻ tr là cha của nút được chọn
      var vRowSelected = $(paramChiTietButton).parents('tr');
      //Lấy datatable row
      var vDatatableRow = gOrderTable.row(vRowSelected); 
      //Lấy data của dòng 
      var vOrderData = vDatatableRow.data();  
      gId = vOrderData.id;
      gOrderID = vOrderData.orderId;
      console.log("Nút chi tiết được nhấn, Dữ liệu của hàng: ");
      console.log(vOrderData);
      console.log("ID :", gId);
      console.log("Order ID :", gOrderID);
      $("#order-detail-modal").modal("show");
      callApiToGetData(gOrderID);
      loadDataToModal (gOrderObjectId);
    }
    function callApiToGetData(paramOrderId){
      "use strict";
      const gBASE_URL = "http://42.115.221.44:8080/devcamp-pizza365/orders";
      $.ajax({
        url: gBASE_URL + "/" + paramOrderId,
        async: false,
        type: "GET",
        dataType: 'json',
        success: function(responseObject){
          //debugger;
          console.log(responseObject);
          gOrderObjectId = responseObject;
        },
            error: function(error){
          console.assert(error.responseText);
        }
      })
      }
      function loadDataToModal(paramOrderObject){
        "use strict";
        $("#input-order-id").val(paramOrderObject.orderId);
        $("#select-co-combo").val(paramOrderObject.kichCo);
        $("#input-duong-kinh-pizza").val(paramOrderObject.duongKinh);
        $("#input-suon-nuong").val(paramOrderObject.suon);
        $("#select-do-uong").val(paramOrderObject.idLoaiNuocUong);
        $("#input-so-luong-nuoc-uong").val(paramOrderObject.soLuongNuoc);
        $("#input-voucher-id").val(paramOrderObject.idVourcher);
        $("#input-pizza-type").val(paramOrderObject.loaiPizza);
        $("#input-salad").val(paramOrderObject.salad);
        $("#input-thanh-tien").val(paramOrderObject.thanhTien);
        $("#input-discount").val(paramOrderObject.giamGia);
        $("#input-email").val(paramOrderObject.email);
        $("#input-full-name").val(paramOrderObject.hoTen);
        $("#input-phone-number").val(paramOrderObject.soDienThoai);
        $("#input-address").val(paramOrderObject.diaChi);
        $("#input-message").val(paramOrderObject.loiNhan);
        $("#input-order-status").val(paramOrderObject.trangThai);
        $("#input-ngay-tao-don").val(paramOrderObject.ngayTao);
        $("#input-ngay-cap-nhat").val(paramOrderObject.ngayCapNhat);
      }
      function getDrinkList(){
        "use strict";
        $.ajax({
          url: "http://42.115.221.44:8080/devcamp-pizza365/drinks",
          type: "GET",
          dataType: 'json',
          success: function(responseObject){
            //debugger;
            console.log(responseObject);
            loadDrinkToModal(responseObject);
          },
            error: function(error){
            console.assert(error.responseText);
          }
      })
      }
      function loadDrinkToModal(paramDrinkObject){
        "use strict";
        $.each(paramDrinkObject, function (i,item){
          $("#select-do-uong").append($('<option>',{
              text: item.tenNuocUong,
              value: item.maNuocUong
          }))
        })
      }
      function loadPizzaSizeToModal(paramPizzaSize){
        "use strict";
        $.each(paramPizzaSize, function (i,item){
          $("#select-co-combo").append($('<option>',{
              text: item,
              value: item
          }))
        })
      }

    })
</script>
</html>